/* This code is from Gonzalo Navarro and Mathieu Raffinot, 1998.
   It can be freely used for academic teaching/learning and research
   purposes. Usage for direct or indirect commercial advantage is not
   allowed without written permission from the authors.
*/


#include <stdio.h>
#include "lzgrep.h"
#include "util.h"
#include "blocks.h"
#include "search.h"

#include "oracle.c"
#include "search_bom_onthefly.h"

typedef unsigned char uchar;


/*************** add a simple word *********************/
void
preproc_bom(int m,unsigned char* motif,int * * T) {
 int i;
 int der;
 int activenode =0;


 *T=allocation_dawg(m+1); /* allocation of the table for the DAWG */
 if (*T==NULL) {
   fprintf(stderr,"impossible to allocate the table for the DAWG");
   exit(-1);
 }

 init_dawg_table(*T,m+1);
 der=0;   /* last state used in the table */

  for(i=m-1;i>=0;i--) {
           dawg_update(*T,&der,&activenode,(int)motif[i]); /* ajout dans le graphe */
    }

}


int *T;


void preproc_bom_onthefly ()
   {
 	int m = PatternList.lmin;
 	
	char *patt = PatternList.next_pattern->pattern;
	//fprintf(stderr," allocate the table for the DAWG con m [%d] e pattern [%s] %d ",PatternList.lmin,patt,patt[0]);
	static int preproc = 0;
	if (!preproc) preproc = 1;
	else return;
	if (patt!=NULL) preproc_bom(m,patt,&T);
   }


int search_bom_onthefly() {

	int rbytes; 
	unsigned char caract;

	register int j,state; 
        register int *T2;

	char *patt = PatternList.next_pattern->pattern;
	int m = PatternList.lmin;
	register int mM1=m-1;
	
	OTF_SearchState OTF_State;
	OTF_cleanState(&OTF_State);
	T2 = T+6;
	j = mM1;
	while ((rbytes=OTF_readUncompressed(&OTF_State))>0) {
		
          
		
		//if ((state = T2[OTF_charAtM(OTF_State.tpos)])  >= 0)
		if (((state = T2[OTF_State.buf[OTF_State.tpos&BUF_MASKM]])  >= 0) && (j>0))
		{
			 OTF_State.excess=mM1;  
			 while (1)
			  {
			     
	  		     if (j == 0) {
					  if (OTF_reportMatch(&OTF_State)) {
						return(OTF_State.count);
					  }
					  break;
			          }
			      j-=1;
			      //state = T2[state*(ALPHABET+6)+ OTF_charAtM (OTF_State.tpos+j) ];
			      state = T2[state*(ALPHABET+6)+ OTF_State.buf[(long)(OTF_State.tpos&BUF_MASKM)+j-mM1] ];
                      
			      if (state == -1) break;
			      
			  }
			 OTF_State.excess=0;
		} 
		 
			
  	      while(OTF_State.tpos+j < OTF_State.rpos) {
                          j = mM1;
		         // while (((state = T2[OTF_charAtM(OTF_State,OTF_State.tpos+j)])  < 0) && (OTF_State.tpos+j < OTF_State.rpos))   
			      while (((state = T2[OTF_State.buf[(OTF_State.tpos+j)&BUF_MASKM]])  < 0) && (OTF_State.tpos+j < OTF_State.rpos))    
				{OTF_shift(OTF_State,m);		
				 caract=OTF_State.buf[(OTF_State.tpos+j)&BUF_MASKM];
}				 	
			  
                         
			  while (OTF_State.tpos+j < OTF_State.rpos)
			  {
			      
	  		     if (j == 0) {
					  //if (
					  OTF_reportMatch(&OTF_State);//) {
						//return(OTF_State.count);
					  //}
					  break;
			          }
			      j-=1;
			      //state = T2[state*(ALPHABET+6)+ OTF_charAtM (OTF_State.tpos+j) ];
			      state = T2[state*(ALPHABET+6)+ OTF_State.buf[(OTF_State.tpos+j)&BUF_MASKM] ];
			      if (state == -1) break;
			  }
		                 OTF_shift(OTF_State,j+1);
		                 caract=OTF_State.buf[(OTF_State.tpos+j)&BUF_MASKM];
			  			  
		}
		//if (OTF_State.tpos>OTF_State.rpos) 
		OTF_State.tpos=OTF_State.rpos;
		//OTF_State.tpos-=j;
	  }
     return(OTF_State.count);
 
}


