
 


#include "selectedSearch.h"
//#include "hash.h"

void StartValid() {

  unsigned x;

  for(x=0;x<128;x++) {
    if(ValidCh(x)) {
      _Valid[x]=1;
      _Invalid[x]=0;
    }
    else {
      _Valid[x]=0;
      _Invalid[x]=1;
    }
  }
  for(x=128;x<256;x++) {
    _Valid[x]=0;
    _Invalid[x]=1;
  }
  _Valid[0]=_Invalid[0]=0;
}

/*-----------------------------------------------------------------------
 Loads the vocabulary used by the decompressor into a hash table. The key of the hash table 
 is the word,  and the value --> the relative position in the ordered vocabulary.
 (or in this case, the codeword associated to it).
 ------------------------------------------------------------------------*/
void loadCompressorHashTable(char * fileName) {
	

	unsigned long int rbytes,abytes;
	unsigned char *text,*top, *pbeg,  *codeStart;
	char *voc;
	static gzFile *gzSearchFile = NULL;
	
	//FILE *voca;
	//voca = fopen ("voc-c", "w");
	
	voc = (char *) malloc(strlen(fileName)+8);
	pbeg = (unsigned char *) malloc (10*BUF_SIZE);
	strcpy(voc,fileName);
	voc[strlen(voc)-3]='\0';
	strcat(voc,".voc.gz");	
	gzSearchFile = gzopen(voc,"r");
		if (!gzSearchFile) {
		        fprintf(stderr, "%s:  Corrupt file\n",
		            voc);
			return;}
	rbytes = gzread(gzSearchFile,pbeg,10*BUF_SIZE);		
	abytes=rbytes;
	while (rbytes>0){
		pbeg = (unsigned char *) realloc (pbeg, abytes+(BUF_SIZE) );
		top=pbeg+abytes;
		rbytes = gzread(gzSearchFile,top,BUF_SIZE);
		abytes=abytes+rbytes;
	}
	gzclose(gzSearchFile);
	text=pbeg;
	
	// Inicialization of the buffers used to read the files

	//v = open (voc, O_RDONLY);
	/*if (v == -1) {
		fprintf(stderr,"Cannot read vocabulary file %s\nSearch aborted.\n",voc);
		exit(0);
	}*/	
 
	//V = bufCreate(MAX_SIZE_OF_WORD+5);	  //a word being "cut"
	//bufSetFile (V,v);
	
	/* loading the vocabulary into memory*/
	//bufCurrent (V,(byte**)&text,(byte**)&top);
	//pbeg = text; pend = top;
	
	
	
			
	{ //Reads the number of words of the vocabulary (stored in the text file as a long value)
		unsigned long numbertmp;
		int z;
		unsigned char *c;
		c= (unsigned char*) &numbertmp;
		for (z=1; z<=4;z++) {
			*c =*pbeg;
			c++;
			pbeg++;
		}
		//fprintf(stderr,"\n\t*Number of words in the vocabulary is: %lu",numbertmp);
	
		initialize_hash(numbertmp); //initializes decompressor for up to N_value words
		/*** ETDC ****/ 
		//Inicializo el vector de palabras ordenado
		words  = (t_word2 *) malloc((numbertmp+1) * sizeof(t_word2));
	}			
	
	/*Reads one word at a time (j) and adds it to the vocabulary vector.*/
	{	unsigned long j;
		unsigned long RELPOS = 0;
		j=0;
		//while(1){
		
			while ( pbeg < top )   {
				//reads the word
				codeStart = pbeg;
				while (*pbeg !='\0') {
					pbeg++;
				}
				
				//adds the word to the vocabulary
				{	
					unsigned long addr;
	
					register unsigned long len;
					unsigned char *w;
					register int i;
			
					len = pbeg-codeStart;
					j = searchHash ((unsigned char *)codeStart, len, &addr);			
											
					//adds the word to the hash Table

					insertElement( codeStart, len,&addr);

					hash[addr].len=len;
					/**** ETDC ****/
					//Inicializo o vector de palabras ordenado
					words[RELPOS].word=hash[addr].word;
					words[RELPOS].len=hash[addr].len;
					{	unsigned long aCode;   //generates the codeword of the word
						getCode(RELPOS,&(aCode), &(hash[addr].size));						
						getBytes(hash[addr].codeword, aCode, hash[addr].size);	
						//hash[addr].codeword = ; hash[addr].len= ;
					
					//fprintf(voca,"\n posicion %d, codigo [%lu], codeword [%lu][%lu][%lu][%lu], size [%u]",RELPOS, aCode,hash[addr].codeword[0],hash[addr].codeword[1],hash[addr].codeword[2],hash[addr].codeword[3] ,hash[addr].size);
					//fprintf(voca,"\n posicion %d, palabra [%.*s]",RELPOS,words[RELPOS].len, words[RELPOS].word);
					}
					RELPOS ++;
				}
			
				j++;
				pbeg++;
			}
			
		//nextbuf=pbeg;
		
		/*bufLoad (V, (char*)nextbuf);
		if (bufEmpty(V)) break;
		bufCurrent (V,(byte**)&text,(byte**)&top);*/
		//pbeg = text; pend = top;
		
		}
	//}
	
	//bufDestroy(V);
	//close(v);
	free(voc);
	free(text);
	//fclose(voca);		
}

/*-----------------------------------------------------------------------
 Loads the next "pattern" from the file of patterns, and stores it into
  structure nextwordpattern (global variable)
 ------------------------------------------------------------------------*/
/*void LoadPatternsFile(FILE *file, unsigned long numPats){

    unsigned long int i;
    unsigned long int numBytesWord;
    unsigned long int frequency;

	//FORMAT OF THE FILE ...
	// [WORD]
	// %s\n"

	for (i=0;i<numPats;i++) {
		fscanf(file,"%s\n", nextwordpattern.word);
		//nextwordpattern.word[numBytesWord]='\0';
		nextwordpattern.numBytesWord = strlen(nextwordpattern.word);
	}
}*/


/*void showMessage() {
	printf("\n* Horspool searcher for End-Tagged Dense Code v0.9 (ETDC)[semistatic compressor]");
	printf("\n* CopyRight(c)2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param\n");
	
    printf("\n  #This program comes with ABSOLUTELY NO WARRANTY; ");
    printf("\n  #This is free software, and you are welcome to redistribute it ");
    printf("\n  #under certain conditions\n\n");
}*/


void imprime_texto_comprimido(int lonx,unsigned char *pos)
{
	register unsigned int i,j;
	register unsigned char *pbeg,*pend,*codeStart;
	const unsigned long TABLABASE[5] = {0,128,16512,2113664,270549120};
	i=0;
	pbeg=pos;
	//fprintf(stderr,"\n Entra con lonx [%d] e apuntando a [%d] [%d] [%d]\n",lonx,*pos, *(pos+1),*(pos+2));
	while ( i < lonx )   {
				//Reads and decodes a codeword
				codeStart = pbeg;
				j=0;
				while (*pbeg >=128) {
					j = j * 128 + (*pbeg - 128);
					pbeg++;
					i++;
				}
				j = j * 128 + *pbeg;
				j += TABLABASE[pbeg - codeStart]; //the position of the word in the vocabulary
                
				
		
				
		 if (_Valid[(unsigned char) words[j].word[0]] ) {
		    if (previous_alfa) 
			   printf(" ");
		       
		       previous_alfa = 1;
	         }
	       else previous_alfa = 0;
	      

	
				
				//fprintf(stderr,"\n j e [%d]",j);
				printf("%.*s",words[j].len,words[j].word);
				
				pbeg++;
				i++;
				
				
				//writeWord(outWriter,words[j].word, words[j].size);
			}/* inner while*/
	printf("\n");		
}


//*********************************************************************
//*********************************************************************
//*********************************************************************

/*int main (int argc, char *argv[]) {
	unsigned int z;
	unsigned char nombreFichTiempos[100];

	unsigned int iterations = 1;
	unsigned int iterActual =1;


	unsigned long pos,i;
	
	tTiempo miTiempo1;
	tTiempo miTiempo2;

	tTiempo miTiempo11;
	tTiempo miTiempo12;

	byte *pattern;   //patterns to be searched for (in each iteration)
	int len;   	   //len of the patterns searched in each iteration

	double totalTime;
	double totalVarianza;
  	totalTime =0.0;
  	totalVarianza = 0.0;

  	showMessage();
  	if (argc < 5) {
		printf("\nUsage: %s <compressedFile> <patternsFile> <iterations> <FTIEMPOS> \n\n", *argv);
		exit(0);
	}

	//prepares the file that will contain the measured times.
	nombreFichTiempos[0]='\0';
	strcat(nombreFichTiempos,argv[4]);
	strcat(nombreFichTiempos,"_.m");
	if ((ftiempos = fopen(nombreFichTiempos,"w")) == NULL)	{
		  fprintf(stderr,
			  "Error opening file for times: %s\n", nombreFichTiempos);
		  exit(0);
	}

	getTiempo(&miTiempo1);
	getTiempo(&miTiempo2);

	//process parameters
	iterations = atoi(argv[3]);

	fprintf(stderr, "fichero de tiempos %s\n", nombreFichTiempos);
	fprintf(stderr, "fichero comprimido: [%s],  fichero vocabulario: [%s]\n", argv[1], argv[2]);
	fprintf(stderr, "iterations [%d]\n", iterations);

	_memMgr = createMemoryManager();

	//opens the file containing the random patterns
	if ((fPatterns = fopen(argv[2],"r")) == NULL)
	{
	  fprintf(stderr,"\nError en la apertura del fichero %s\n", argv[2]);
	  exit(0);
	}
	
		
	//loads the vocabulary of the compressor into a hash table that will be used to obtain
	//the codewords associated to a search pattern (a word), previously to perform a search.
	loadCompressorHashTable(argv[1]);


	//FOR LOOP OF ITERATIONS STARTS. ******************
	getTiempo(&miTiempo11);
	getTiempo(&miTiempo1);

	// iterations ... *****************************************************
	
	for (;iterActual <= iterations; iterActual++) {
		
		fprintf(stderr,"\n Search: %d of %d",iterActual,iterations);
		
		//Read next random pattern...
		fprintf(stderr, "\n READING NEXT RANDOM PATTERN... \n");
		
		LoadPatternsFile(fPatterns,1);   //loads the next ("1") pattern from the "patterns file"
								
		//Once the compressed patterns is known, we search for it into the file.
		//  Time measures take only into account the time needed to search for each pattern inside the hash table
		//  of patterns, and the traversing the full file searching for the compressed search patterns. 
		//  It skips times needed to load the vocabulary, the hash table, ...
		
		getTiempo(&miTiempo1);
		
		{//Searches for the loaded patterns inside the hash table 
		 //	and obtains their codeword and codeword lenght.
			unsigned long addr;
					
			z=search (nextwordpattern.word, nextwordpattern.numBytesWord, &addr);	
			fprintf(stderr, "\n  chosen word: [%s],  codesize [%d]\n ",nextwordpattern.word,hash[addr].size);
			
			pattern= (byte *) hash[addr].codeword;
			len = hash[addr].size;			
		}

		//searches inside the compressed file.
		searchFullFile(argv[1],pattern,len);

		getTiempo(&miTiempo2);
		
		
		totalTime  += miTiempo2.user - miTiempo1.user;	
		totalVarianza += ((miTiempo2.user - miTiempo1.user) * (miTiempo2.user - miTiempo1.user));
		
		fprintf(ftiempos,"%s(%d) = %f ;\n", argv[4],(iterActual) , miTiempo2.user - miTiempo1.user);
		fflush(ftiempos);
		muestraTiempo(miTiempo1,miTiempo2,"SEARCH TIME");
	
		
	} //end for iterations. *****************************************************

	getTiempo(&miTiempo12);

	
	//Gives some statistics of the current run...
	fprintf(stderr,"\n AVG USER TIME (only search process) = %f sec.",totalTime/iterations);
	{	double varr;		
		varr= (totalVarianza / iterations) - ((totalTime / iterations) *(totalTime / iterations));
		fprintf(stderr,"\n Desv est : %f  ", sqrt(varr * iterations / (iterations -1))  );
		fprintf(stderr,"\n Varianza : %f  ", varr  );
		fprintf(stderr,"\n Desv tp : %f  \n\n", sqrt(varr)  );
		
			
		fprintf(ftiempos,"mean(%s) %% %f \n", argv[4],totalTime/iterations );
		fprintf(ftiempos,"std(%s)  %% %f \n", argv[4],sqrt(varr * iterations / (iterations -1)) );
		fprintf(ftiempos,"%s=sort(%s);\n", argv[4],argv[4]  );
		fprintf(ftiempos,"plot(%s,'b')\n", argv[4]);
	}
	
	//Frees memory, closes file handlers ...........
	fclose (ftiempos);
	fclose (fPatterns);
	
	freeHashTable();
}*/
