/* Searches using  Horspool's algorithm adapted to 
search inside a text compressed with End-Tagged Dense Code.
Lightweight Natural Language Text Compression: Information Retrieval 2006

Programmed by Antonio Faria.

Author's contact: Antonio Faria, Databases Lab, University of
A Corua. Campus de Elvia s/n. Spain  fari@udc.es

Copyright (C) 2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param
Author's contact: antonio.fari@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


/*-----------------------------------------------------------------------
  search.h:  Implements the 2 following functions:
  			- searchInBufferETDC (searching for a pattern in a buffer)
  			- searchFullFile (leading the process of searching in all the buffers of a file)  			
 ------------------------------------------------------------------------*/

#ifndef SEARCHERINCLUDED
#define SEARCHERINCLUDED
#endif

#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <malloc.h>
#include <stdio.h>

#include "BufferedReader.h"

#define MIN(a,b) (a < b) ? a : b
#define MAX(a,b) (a > b) ? a : b

#define LINE_UP(x,numBytes) ((x>>(4-numBytes)*8))   //move "4-bytes" bytes to the right
						   						   	//so we can write "bytes" bytes from &x
#ifdef LITTLE_ENDIAN
	#define LE_LONG32(x)  (((x&0xff000000)>>24)|((x&0x00ff0000)>>8)|((x&0x0000ff00)<<8)|((x&0x000000ff)<<24))
#else
	#define LE_LONG32(x) x
#endif



#ifdef CONTADOR_BYTES_ENABLED
	long LEIDOS;
#endif

#ifdef LOGGING_ENABLED
	FILE *fLOG2;
#endif 

int S_value;
int C_value;


/*********************************************/

	/*unsigned int searchInBufferETDC (BufferRead B, byte **begin, byte **end,unsigned long pos,
					 byte *code, unsigned int len, byte *d );

	unsigned int searchFullFile (char *infile, byte *code, int len);*/

void getBytes(unsigned char *code, unsigned long number, int numBytes);
void getCode(register unsigned long position,
						register unsigned long *codeword, register unsigned long *k);
						
void printCodigo (byte *cw, int size);

